package jakarta.nosql.test;

import jakarta.nosql.document.DocumentCollectionManager;
import jakarta.nosql.document.DocumentCollectionManagerFactory;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import org.eclipse.jnosql.communication.mongodb.document.MongoDBDocumentConfiguration;
import org.jboss.weld.util.collections.ImmutableMap;

@ApplicationScoped
public class ManagerProducer {

    private DocumentCollectionManager manager;
    
    @PostConstruct
    public void init() {
        DocumentCollectionManagerFactory factory = new MongoDBDocumentConfiguration().get(
                ImmutableMap.of("mongodb-server-host-1", "localhost:27017"));
        manager = factory.get("citizens");
    }
    
    @Produces
    public DocumentCollectionManager getManagerFactory() {
        return manager;
    }

    @PreDestroy
    public void destroy() {
        manager.close();
    }    
}
